/**
* DevExtreme (file_management/upload_info.d.ts)
* Version: 20.2.1 (build 20239-0312)
* Build date: Wed Aug 26 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
/** Warning! This type is used for internal purposes. Do not import it directly. */
/** An object that provides information about the file upload session. */
export default interface UploadInfo {
    /** The number of bytes that is uploaded to the server. */
    bytesUploaded: number;

    /** The number of uploaded chunks and chunks that are to be uploaded. */
    chunkCount: number;

    /** Information saved during the file upload. */
    customData: any;

    /** The binary content of the uploading chunk. */
    chunkBlob: Blob;

    /** The index of the uploading chunk. */
    chunkIndex: number;
}