/**
 * DevExtreme (renovation/ui/data_grid/data_grid.js)
 * Version: 20.2.1 (build 20239-0312)
 * Build date: Wed Aug 26 2020
 *
 * Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";

function _typeof(obj) {
    "@babel/helpers - typeof";
    if ("function" === typeof Symbol && "symbol" === typeof Symbol.iterator) {
        _typeof = function(obj) {
            return typeof obj
        }
    } else {
        _typeof = function(obj) {
            return obj && "function" === typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj
        }
    }
    return _typeof(obj)
}
exports.DataGrid = DataGrid;
exports.viewFunction = void 0;
var _data_grid = _interopRequireDefault(require("../../../ui/data_grid"));
var _props = require("./props");
var Preact = _interopRequireWildcard(require("preact"));
var _hooks = require("preact/hooks");

function _getRequireWildcardCache() {
    if ("function" !== typeof WeakMap) {
        return null
    }
    var cache = new WeakMap;
    _getRequireWildcardCache = function() {
        return cache
    };
    return cache
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj
    }
    if (null === obj || "object" !== _typeof(obj) && "function" !== typeof obj) {
        return {
            "default": obj
        }
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
        return cache.get(obj)
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc)
            } else {
                newObj[key] = obj[key]
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj)
    }
    return newObj
}

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable
            })
        }
        keys.push.apply(keys, symbols)
    }
    return keys
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        if (i % 2) {
            ownKeys(Object(source), true).forEach(function(key) {
                _defineProperty(target, key, source[key])
            })
        } else {
            if (Object.getOwnPropertyDescriptors) {
                Object.defineProperties(target, Object.getOwnPropertyDescriptors(source))
            } else {
                ownKeys(Object(source)).forEach(function(key) {
                    Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key))
                })
            }
        }
    }
    return target
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        })
    } else {
        obj[key] = value
    }
    return obj
}

function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest()
}

function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")
}

function _unsupportedIterableToArray(o, minLen) {
    if (!o) {
        return
    }
    if ("string" === typeof o) {
        return _arrayLikeToArray(o, minLen)
    }
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if ("Object" === n && o.constructor) {
        n = o.constructor.name
    }
    if ("Map" === n || "Set" === n) {
        return Array.from(o)
    }
    if ("Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) {
        return _arrayLikeToArray(o, minLen)
    }
}

function _arrayLikeToArray(arr, len) {
    if (null == len || len > arr.length) {
        len = arr.length
    }
    for (var i = 0, arr2 = new Array(len); i < len; i++) {
        arr2[i] = arr[i]
    }
    return arr2
}

function _iterableToArrayLimit(arr, i) {
    if ("undefined" === typeof Symbol || !(Symbol.iterator in Object(arr))) {
        return
    }
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = void 0;
    try {
        for (var _s, _i = arr[Symbol.iterator](); !(_n = (_s = _i.next()).done); _n = true) {
            _arr.push(_s.value);
            if (i && _arr.length === i) {
                break
            }
        }
    } catch (err) {
        _d = true;
        _e = err
    } finally {
        try {
            if (!_n && null != _i.return) {
                _i.return()
            }
        } finally {
            if (_d) {
                throw _e
            }
        }
    }
    return _arr
}

function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) {
        return arr
    }
}

function _extends() {
    _extends = Object.assign || function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}
var viewFunction = function(_ref) {
    var className = _ref.props.className,
        restAttributes = _ref.restAttributes,
        widgetRef = _ref.widgetRef;
    return Preact.h("div", _extends({
        ref: widgetRef,
        className: className
    }, restAttributes))
};
exports.viewFunction = viewFunction;

function getTemplate(props, template, render, component) {
    var getRender = function(render) {
        return function(props) {
            return "data" in props ? render(props.data, props.index) : render(props)
        }
    };
    var Component = props[component];
    return props[template] || props[render] && getRender(props[render]) || Component && function(props) {
        return Preact.h(Component, _extends({}, props))
    }
}

function DataGrid(props) {
    var widgetRef = (0, _hooks.useRef)();
    var _useState = (0, _hooks.useState)(function() {
            return void 0 !== props.filterValue ? props.filterValue : props.defaultFilterValue
        }),
        _useState2 = _slicedToArray(_useState, 2),
        __state_filterValue = _useState2[0];
    _useState2[1];
    var _useState3 = (0, _hooks.useState)(function() {
            return void 0 !== props.focusedColumnIndex ? props.focusedColumnIndex : props.defaultFocusedColumnIndex
        }),
        _useState4 = _slicedToArray(_useState3, 2),
        __state_focusedColumnIndex = _useState4[0];
    _useState4[1];
    var _useState5 = (0, _hooks.useState)(function() {
            return void 0 !== props.focusedRowIndex ? props.focusedRowIndex : props.defaultFocusedRowIndex
        }),
        _useState6 = _slicedToArray(_useState5, 2),
        __state_focusedRowIndex = _useState6[0];
    _useState6[1];
    var _useState7 = (0, _hooks.useState)(function() {
            return void 0 !== props.focusedRowKey ? props.focusedRowKey : props.defaultFocusedRowKey
        }),
        _useState8 = _slicedToArray(_useState7, 2),
        __state_focusedRowKey = _useState8[0];
    _useState8[1];
    var _useState9 = (0, _hooks.useState)(function() {
            return void 0 !== props.selectedRowKeys ? props.selectedRowKeys : props.defaultSelectedRowKeys
        }),
        _useState10 = _slicedToArray(_useState9, 2),
        __state_selectedRowKeys = _useState10[0];
    _useState10[1];
    var _useState11 = (0, _hooks.useState)(function() {
            return void 0 !== props.selectionFilter ? props.selectionFilter : props.defaultSelectionFilter
        }),
        _useState12 = _slicedToArray(_useState11, 2),
        __state_selectionFilter = _useState12[0];
    _useState12[1];
    var __properties = (0, _hooks.useCallback)(function() {
        return _objectSpread(_objectSpread({}, props), {}, {
            filterValue: void 0 !== props.filterValue ? props.filterValue : __state_filterValue,
            focusedColumnIndex: void 0 !== props.focusedColumnIndex ? props.focusedColumnIndex : __state_focusedColumnIndex,
            focusedRowIndex: void 0 !== props.focusedRowIndex ? props.focusedRowIndex : __state_focusedRowIndex,
            focusedRowKey: void 0 !== props.focusedRowKey ? props.focusedRowKey : __state_focusedRowKey,
            selectedRowKeys: void 0 !== props.selectedRowKeys ? props.selectedRowKeys : __state_selectedRowKeys,
            selectionFilter: void 0 !== props.selectionFilter ? props.selectionFilter : __state_selectionFilter
        })
    }, [props, __state_filterValue, __state_focusedColumnIndex, __state_focusedRowIndex, __state_focusedRowKey, __state_selectedRowKeys, __state_selectionFilter]);
    var __restAttributes = (0, _hooks.useCallback)(function() {
        var _props$filterValue$fo = _objectSpread(_objectSpread({}, props), {}, {
                filterValue: void 0 !== props.filterValue ? props.filterValue : __state_filterValue,
                focusedColumnIndex: void 0 !== props.focusedColumnIndex ? props.focusedColumnIndex : __state_focusedColumnIndex,
                focusedRowIndex: void 0 !== props.focusedRowIndex ? props.focusedRowIndex : __state_focusedRowIndex,
                focusedRowKey: void 0 !== props.focusedRowKey ? props.focusedRowKey : __state_focusedRowKey,
                selectedRowKeys: void 0 !== props.selectedRowKeys ? props.selectedRowKeys : __state_selectedRowKeys,
                selectionFilter: void 0 !== props.selectionFilter ? props.selectionFilter : __state_selectionFilter
            }),
            restProps = (_props$filterValue$fo._feedbackHideTimeout, _props$filterValue$fo._feedbackShowTimeout, _props$filterValue$fo.accessKey, _props$filterValue$fo.activeStateEnabled, _props$filterValue$fo.activeStateUnit, _props$filterValue$fo.allowColumnReordering, _props$filterValue$fo.allowColumnResizing, _props$filterValue$fo.aria, _props$filterValue$fo.autoNavigateToFocusedRow, _props$filterValue$fo.cacheEnabled, _props$filterValue$fo.cellHintEnabled, _props$filterValue$fo.children, _props$filterValue$fo.className, _props$filterValue$fo.classes, _props$filterValue$fo.columnAutoWidth, _props$filterValue$fo.columnChooser, _props$filterValue$fo.columnFixing, _props$filterValue$fo.columnHidingEnabled, _props$filterValue$fo.columnMinWidth, _props$filterValue$fo.columnResizingMode, _props$filterValue$fo.columnWidth, _props$filterValue$fo.columns, _props$filterValue$fo.customizeColumns, _props$filterValue$fo.customizeExportData, _props$filterValue$fo.dataSource, _props$filterValue$fo.dateSerializationFormat, _props$filterValue$fo.defaultFilterValue, _props$filterValue$fo.defaultFocusedColumnIndex, _props$filterValue$fo.defaultFocusedRowIndex, _props$filterValue$fo.defaultFocusedRowKey, _props$filterValue$fo.defaultSelectedRowKeys, _props$filterValue$fo.defaultSelectionFilter, _props$filterValue$fo.disabled, _props$filterValue$fo.editing, _props$filterValue$fo.errorRowEnabled, _props$filterValue$fo.filterBuilder, _props$filterValue$fo.filterBuilderPopup, _props$filterValue$fo.filterPanel, _props$filterValue$fo.filterRow, _props$filterValue$fo.filterSyncEnabled, _props$filterValue$fo.filterValue, _props$filterValue$fo.filterValueChange, _props$filterValue$fo.focusStateEnabled, _props$filterValue$fo.focusedColumnIndex, _props$filterValue$fo.focusedColumnIndexChange, _props$filterValue$fo.focusedRowEnabled, _props$filterValue$fo.focusedRowIndex, _props$filterValue$fo.focusedRowIndexChange, _props$filterValue$fo.focusedRowKey, _props$filterValue$fo.focusedRowKeyChange, _props$filterValue$fo.groupPanel, _props$filterValue$fo.grouping, _props$filterValue$fo.headerFilter, _props$filterValue$fo.height, _props$filterValue$fo.highlightChanges, _props$filterValue$fo.hint, _props$filterValue$fo.hoverStateEnabled, _props$filterValue$fo.keyExpr, _props$filterValue$fo.keyboardNavigation, _props$filterValue$fo.loadPanel, _props$filterValue$fo.masterDetail, _props$filterValue$fo.name, _props$filterValue$fo.noDataText, _props$filterValue$fo.onActive, _props$filterValue$fo.onAdaptiveDetailRowPreparing, _props$filterValue$fo.onCellClick, _props$filterValue$fo.onCellDblClick, _props$filterValue$fo.onCellHoverChanged, _props$filterValue$fo.onCellPrepared, _props$filterValue$fo.onClick, _props$filterValue$fo.onContentReady, _props$filterValue$fo.onContextMenuPreparing, _props$filterValue$fo.onDataErrorOccurred, _props$filterValue$fo.onDimensionChanged, _props$filterValue$fo.onEditingStart, _props$filterValue$fo.onEditorPrepared, _props$filterValue$fo.onEditorPreparing, _props$filterValue$fo.onExported, _props$filterValue$fo.onExporting, _props$filterValue$fo.onFileSaving, _props$filterValue$fo.onFocusIn, _props$filterValue$fo.onFocusOut, _props$filterValue$fo.onFocusedCellChanged, _props$filterValue$fo.onFocusedCellChanging, _props$filterValue$fo.onFocusedRowChanged, _props$filterValue$fo.onFocusedRowChanging, _props$filterValue$fo.onInactive, _props$filterValue$fo.onInitNewRow, _props$filterValue$fo.onKeyDown, _props$filterValue$fo.onKeyboardHandled, _props$filterValue$fo.onRowClick, _props$filterValue$fo.onRowCollapsed, _props$filterValue$fo.onRowCollapsing, _props$filterValue$fo.onRowDblClick, _props$filterValue$fo.onRowExpanded, _props$filterValue$fo.onRowExpanding, _props$filterValue$fo.onRowInserted, _props$filterValue$fo.onRowInserting, _props$filterValue$fo.onRowPrepared, _props$filterValue$fo.onRowRemoved, _props$filterValue$fo.onRowRemoving, _props$filterValue$fo.onRowUpdated, _props$filterValue$fo.onRowUpdating, _props$filterValue$fo.onRowValidating, _props$filterValue$fo.onSelectionChanged, _props$filterValue$fo.onToolbarPreparing, _props$filterValue$fo.onVisibilityChange, _props$filterValue$fo.pager, _props$filterValue$fo.paging, _props$filterValue$fo.remoteOperations, _props$filterValue$fo.renderAsync, _props$filterValue$fo.repaintChangesOnly, _props$filterValue$fo.rowAlternationEnabled, _props$filterValue$fo.rowComponent, _props$filterValue$fo.rowDragging, _props$filterValue$fo.rowRender, _props$filterValue$fo.rowTemplate, _props$filterValue$fo.rtlEnabled, _props$filterValue$fo.scrolling, _props$filterValue$fo.searchPanel, _props$filterValue$fo.selectedRowKeys, _props$filterValue$fo.selectedRowKeysChange, _props$filterValue$fo.selection, _props$filterValue$fo.selectionFilter, _props$filterValue$fo.selectionFilterChange, _props$filterValue$fo.showBorders, _props$filterValue$fo.showColumnHeaders, _props$filterValue$fo.showColumnLines, _props$filterValue$fo.showRowLines, _props$filterValue$fo.sortByGroupSummaryInfo, _props$filterValue$fo.sorting, _props$filterValue$fo.stateStoring, _props$filterValue$fo.summary, _props$filterValue$fo.tabIndex, _props$filterValue$fo.twoWayBindingEnabled, _props$filterValue$fo.visible, _props$filterValue$fo.width, _props$filterValue$fo.wordWrapEnabled, _objectWithoutProperties(_props$filterValue$fo, ["_feedbackHideTimeout", "_feedbackShowTimeout", "accessKey", "activeStateEnabled", "activeStateUnit", "allowColumnReordering", "allowColumnResizing", "aria", "autoNavigateToFocusedRow", "cacheEnabled", "cellHintEnabled", "children", "className", "classes", "columnAutoWidth", "columnChooser", "columnFixing", "columnHidingEnabled", "columnMinWidth", "columnResizingMode", "columnWidth", "columns", "customizeColumns", "customizeExportData", "dataSource", "dateSerializationFormat", "defaultFilterValue", "defaultFocusedColumnIndex", "defaultFocusedRowIndex", "defaultFocusedRowKey", "defaultSelectedRowKeys", "defaultSelectionFilter", "disabled", "editing", "errorRowEnabled", "filterBuilder", "filterBuilderPopup", "filterPanel", "filterRow", "filterSyncEnabled", "filterValue", "filterValueChange", "focusStateEnabled", "focusedColumnIndex", "focusedColumnIndexChange", "focusedRowEnabled", "focusedRowIndex", "focusedRowIndexChange", "focusedRowKey", "focusedRowKeyChange", "groupPanel", "grouping", "headerFilter", "height", "highlightChanges", "hint", "hoverStateEnabled", "keyExpr", "keyboardNavigation", "loadPanel", "masterDetail", "name", "noDataText", "onActive", "onAdaptiveDetailRowPreparing", "onCellClick", "onCellDblClick", "onCellHoverChanged", "onCellPrepared", "onClick", "onContentReady", "onContextMenuPreparing", "onDataErrorOccurred", "onDimensionChanged", "onEditingStart", "onEditorPrepared", "onEditorPreparing", "onExported", "onExporting", "onFileSaving", "onFocusIn", "onFocusOut", "onFocusedCellChanged", "onFocusedCellChanging", "onFocusedRowChanged", "onFocusedRowChanging", "onInactive", "onInitNewRow", "onKeyDown", "onKeyboardHandled", "onRowClick", "onRowCollapsed", "onRowCollapsing", "onRowDblClick", "onRowExpanded", "onRowExpanding", "onRowInserted", "onRowInserting", "onRowPrepared", "onRowRemoved", "onRowRemoving", "onRowUpdated", "onRowUpdating", "onRowValidating", "onSelectionChanged", "onToolbarPreparing", "onVisibilityChange", "pager", "paging", "remoteOperations", "renderAsync", "repaintChangesOnly", "rowAlternationEnabled", "rowComponent", "rowDragging", "rowRender", "rowTemplate", "rtlEnabled", "scrolling", "searchPanel", "selectedRowKeys", "selectedRowKeysChange", "selection", "selectionFilter", "selectionFilterChange", "showBorders", "showColumnHeaders", "showColumnLines", "showRowLines", "sortByGroupSummaryInfo", "sorting", "stateStoring", "summary", "tabIndex", "twoWayBindingEnabled", "visible", "width", "wordWrapEnabled"]));
        return restProps
    }, [props, __state_filterValue, __state_focusedColumnIndex, __state_focusedRowIndex, __state_focusedRowKey, __state_selectedRowKeys, __state_selectionFilter]);
    (0, _hooks.useEffect)(function() {
        var widget = _data_grid.default.getInstance(widgetRef.current);
        null === widget || void 0 === widget ? void 0 : widget.option(__properties())
    }, [props, __state_filterValue, __state_focusedColumnIndex, __state_focusedRowIndex, __state_focusedRowKey, __state_selectedRowKeys, __state_selectionFilter]);
    (0, _hooks.useEffect)(function() {
        var widget = new _data_grid.default(widgetRef.current, __properties());
        return function() {
            widget.dispose()
        }
    }, []);
    return viewFunction({
        props: _objectSpread(_objectSpread({}, props), {}, {
            filterValue: void 0 !== props.filterValue ? props.filterValue : __state_filterValue,
            focusedColumnIndex: void 0 !== props.focusedColumnIndex ? props.focusedColumnIndex : __state_focusedColumnIndex,
            focusedRowIndex: void 0 !== props.focusedRowIndex ? props.focusedRowIndex : __state_focusedRowIndex,
            focusedRowKey: void 0 !== props.focusedRowKey ? props.focusedRowKey : __state_focusedRowKey,
            selectedRowKeys: void 0 !== props.selectedRowKeys ? props.selectedRowKeys : __state_selectedRowKeys,
            selectionFilter: void 0 !== props.selectionFilter ? props.selectionFilter : __state_selectionFilter,
            rowTemplate: getTemplate(props, "rowTemplate", "rowRender", "rowComponent")
        }),
        widgetRef: widgetRef,
        properties: __properties(),
        restAttributes: __restAttributes()
    })
}
DataGrid.defaultProps = _objectSpread({}, _props.DataGridProps);
