/**
 * DevExtreme (renovation/ui/list.js)
 * Version: 20.2.1 (build 20239-0312)
 * Build date: Wed Aug 26 2020
 *
 * Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";

function _typeof(obj) {
    "@babel/helpers - typeof";
    if ("function" === typeof Symbol && "symbol" === typeof Symbol.iterator) {
        _typeof = function(obj) {
            return typeof obj
        }
    } else {
        _typeof = function(obj) {
            return obj && "function" === typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj
        }
    }
    return _typeof(obj)
}
exports.List = List;
exports.ListProps = exports.viewFunction = void 0;
var _widget = require("./common/widget");
var _list = _interopRequireDefault(require("../../ui/list"));
var _render_template = _interopRequireDefault(require("../utils/render_template"));
var Preact = _interopRequireWildcard(require("preact"));
var _hooks = require("preact/hooks");

function _getRequireWildcardCache() {
    if ("function" !== typeof WeakMap) {
        return null
    }
    var cache = new WeakMap;
    _getRequireWildcardCache = function() {
        return cache
    };
    return cache
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj
    }
    if (null === obj || "object" !== _typeof(obj) && "function" !== typeof obj) {
        return {
            "default": obj
        }
    }
    var cache = _getRequireWildcardCache();
    if (cache && cache.has(obj)) {
        return cache.get(obj)
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc)
            } else {
                newObj[key] = obj[key]
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj)
    }
    return newObj
}

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}

function _objectWithoutProperties(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i = 0; i < sourceSymbolKeys.length; i++) {
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) {
                continue
            }
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) {
                continue
            }
            target[key] = source[key]
        }
    }
    return target
}

function _objectWithoutPropertiesLoose(source, excluded) {
    if (null == source) {
        return {}
    }
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) {
            continue
        }
        target[key] = source[key]
    }
    return target
}

function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable
            })
        }
        keys.push.apply(keys, symbols)
    }
    return keys
}

function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
        var source = null != arguments[i] ? arguments[i] : {};
        if (i % 2) {
            ownKeys(Object(source), true).forEach(function(key) {
                _defineProperty(target, key, source[key])
            })
        } else {
            if (Object.getOwnPropertyDescriptors) {
                Object.defineProperties(target, Object.getOwnPropertyDescriptors(source))
            } else {
                ownKeys(Object(source)).forEach(function(key) {
                    Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key))
                })
            }
        }
    }
    return target
}

function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        })
    } else {
        obj[key] = value
    }
    return obj
}
var viewFunction = function(viewModel) {
    return Preact.h("div", {
        ref: viewModel.widgetRef
    })
};
exports.viewFunction = viewFunction;
var ListProps = _objectSpread({}, _widget.WidgetProps);
exports.ListProps = ListProps;

function List(props) {
    var widgetRef = (0, _hooks.useRef)();
    var __properties = (0, _hooks.useCallback)(function() {
        var itemTemplate = props.itemTemplate,
            restProps = _objectWithoutProperties(props, ["itemTemplate"]);
        var template = itemTemplate ? function(item, index, container) {
            (0, _render_template.default)(itemTemplate, {
                item: item,
                index: index,
                container: container
            }, container)
        } : void 0;
        return _objectSpread(_objectSpread({}, restProps), {}, {
            itemTemplate: template
        })
    }, [props]);
    var __restAttributes = (0, _hooks.useCallback)(function() {
        var restProps = (props._feedbackHideTimeout, props._feedbackShowTimeout, props.accessKey, props.activeStateEnabled, props.activeStateUnit, props.aria, props.children, props.className, props.classes, props.dataSource, props.disabled, props.focusStateEnabled, props.height, props.hint, props.hoverStateEnabled, props.itemTemplate, props.name, props.onActive, props.onClick, props.onContentReady, props.onDimensionChanged, props.onFocusIn, props.onFocusOut, props.onInactive, props.onItemClick, props.onKeyDown, props.onKeyboardHandled, props.onVisibilityChange, props.rtlEnabled, props.tabIndex, props.visible, props.width, _objectWithoutProperties(props, ["_feedbackHideTimeout", "_feedbackShowTimeout", "accessKey", "activeStateEnabled", "activeStateUnit", "aria", "children", "className", "classes", "dataSource", "disabled", "focusStateEnabled", "height", "hint", "hoverStateEnabled", "itemTemplate", "name", "onActive", "onClick", "onContentReady", "onDimensionChanged", "onFocusIn", "onFocusOut", "onInactive", "onItemClick", "onKeyDown", "onKeyboardHandled", "onVisibilityChange", "rtlEnabled", "tabIndex", "visible", "width"]));
        return restProps
    }, [props]);
    (0, _hooks.useEffect)(function() {
        var widget = _list.default.getInstance(widgetRef.current);
        null === widget || void 0 === widget ? void 0 : widget.option(__properties())
    }, [props]);
    (0, _hooks.useEffect)(function() {
        var widget = new _list.default(widgetRef.current, __properties());
        return function() {
            return widget.dispose()
        }
    }, []);
    return viewFunction({
        props: _objectSpread({}, props),
        widgetRef: widgetRef,
        properties: __properties(),
        restAttributes: __restAttributes()
    })
}
List.defaultProps = _objectSpread({}, ListProps);
