/**
 * DevExtreme (ui/html_editor/matchers/newLine.js)
 * Version: 20.2.1 (build 20239-0312)
 * Build date: Wed Aug 26 2020
 *
 * Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.default = void 0;

function isLine(node) {
    if (0 === node.childNodes.length) {
        return false
    }
    return ["address", "article", "blockquote", "canvas", "dd", "div", "dl", "dt", "fieldset", "figcaption", "figure", "footer", "form", "h1", "h2", "h3", "h4", "h5", "h6", "header", "iframe", "li", "main", "nav", "ol", "output", "p", "pre", "section", "table", "td", "tr", "ul", "video"].indexOf(node.tagName.toLowerCase()) !== -1
}

function deltaEndsWithNewLine(delta) {
    var _ref = delta.ops[delta.ops.length - 1] || {},
        text = _ref.insert;
    if ("string" !== typeof text) {
        return false
    }
    return "\n" === text.slice(-1)
}
var getMatcher = function() {
    return function(node, delta) {
        if (!deltaEndsWithNewLine(delta)) {
            if (isLine(node)) {
                return delta.insert("\n")
            }
        }
        return delta
    }
};
var _default = getMatcher;
exports.default = _default;
module.exports = exports.default;
