/**
 * DevExtreme (ui/scheduler/timeZoneCalculator.js)
 * Version: 20.2.1 (build 20239-0312)
 * Build date: Wed Aug 26 2020
 *
 * Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.PathTimeZoneConversion = exports.TimeZoneCalculator = void 0;

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function")
    }
}

function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) {
            descriptor.writable = true
        }
        Object.defineProperty(target, descriptor.key, descriptor)
    }
}

function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) {
        _defineProperties(Constructor.prototype, protoProps)
    }
    if (staticProps) {
        _defineProperties(Constructor, staticProps)
    }
    return Constructor
}
var TimeZoneCalculator = function() {
    function TimeZoneCalculator(scheduler) {
        _classCallCheck(this, TimeZoneCalculator);
        this.scheduler = scheduler
    }
    _createClass(TimeZoneCalculator, [{
        key: "createDate",
        value: function(sourceDate, info) {
            var date = new Date(sourceDate);
            switch (info.path) {
                case PathTimeZoneConversion.fromSourceToAppointment:
                    return this.scheduler.fire("convertDateByTimezone", date, info.appointmentTimeZone, true);
                case PathTimeZoneConversion.fromAppointmentToSource:
                    return this.scheduler.fire("convertDateByTimezoneBack", date, info.appointmentTimeZone, true);
                case PathTimeZoneConversion.fromSourceToGrid:
                    return this.scheduler.fire("convertDateByTimezone", date, info.appointmentTimeZone);
                case PathTimeZoneConversion.fromGridToSource:
                    return this.scheduler.fire("convertDateByTimezoneBack", date, info.appointmentTimeZone)
            }
            throw new Error("not specified pathTimeZoneConversion")
        }
    }]);
    return TimeZoneCalculator
}();
exports.TimeZoneCalculator = TimeZoneCalculator;
var PathTimeZoneConversion = {
    fromSourceToAppointment: "toAppointment",
    fromAppointmentToSource: "fromAppointment",
    fromSourceToGrid: "toGrid",
    fromGridToSource: "fromGrid"
};
exports.PathTimeZoneConversion = PathTimeZoneConversion;
