/**
 * DevExtreme (viz/tree_map/drilldown.js)
 * Version: 20.2.1 (build 20239-0312)
 * Build date: Wed Aug 26 2020
 *
 * Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
var _tree_map = require("./tree_map.base");
var _helpers = require("../core/helpers");
require("./api");
_tree_map.prototype._eventsMap.onDrill = {
    name: "drill"
};
(0, _helpers.expand)(_tree_map.prototype, "_extendProxyType", function(proto) {
    var that = this;
    proto.drillDown = function() {
        that._drillToNode(this._id)
    }
});
(0, _helpers.expand)(_tree_map.prototype, "_onNodesCreated", function() {
    this._drilldownIndex = -1
});
_tree_map.prototype._drillToNode = function(index) {
    var that = this;
    var node;
    if (that._drilldownIndex !== index) {
        node = that._nodes[index] || that._root;
        if (node.nodes) {
            that._drilldownIndex = index;
            that._topNode = node;
            that._context.suspend();
            that._context.change(["MAX_DEPTH", "NODES_RESET"]);
            that._context.resume();
            that._eventTrigger("drill", {
                node: node.proxy
            })
        }
    }
};
_tree_map.prototype.resetDrillDown = function() {
    this._drillToNode(-1);
    return this
};
_tree_map.prototype.drillUp = function() {
    this._drillToNode(this._topNode.parent._id || -1);
    return this
};
_tree_map.prototype.getCurrentNode = function() {
    return this._topNode.proxy
};
