/**
 * DevExtreme (viz/tree_map/states.js)
 * Version: 20.2.1 (build 20239-0312)
 * Build date: Wed Aug 26 2020
 *
 * Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
var _tree_map = require("./tree_map.base");
var _node = require("./node");
var _common = require("../../core/utils/common");
var _extend2 = require("../../core/utils/extend");
var handlers = _tree_map.prototype._handlers;
var _calculateState = handlers.calculateState;
var _buildState = _node.prototype._buildState;
handlers.calculateState = function(options) {
    var states = {
        0: _calculateState(options)
    };
    handlers.calculateAdditionalStates(states, options);
    return states
};
handlers.calculateAdditionalStates = _common.noop;
_node.prototype.code = 0;
_node.prototype.statesMap = {
    0: 0
};
_node.prototype.additionalStates = [];
_node.prototype._buildState = function(state, extra) {
    var states = {
        0: _buildState(state[0], extra)
    };
    if (this.additionalStates.length) {
        buildAdditionalStates(states, states[0], state, this.additionalStates)
    }
    return states
};
_node.prototype._getState = function() {
    return this.state[this.statesMap[this.code]]
};
_node.prototype.setState = function(code, state) {
    if (state) {
        this.code |= code
    } else {
        this.code &= ~code
    }
    this.ctx.change(["TILES"])
};

function buildAdditionalStates(states, base, source, list) {
    var i;
    var ii = list.length;
    for (i = 0; i < ii; ++i) {
        states[list[i]] = (0, _extend2.extend)({}, base, source[list[i]])
    }
}
